<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
</head>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        $("#table-users").on("click", ".edit-user", function () {
            onBtnEditClick(this);
        })
        $("#table-users").on("click", ".delete-user", function () {
            onBtnDeleteClick(this);
        });
        $("#btn-them-user").on("click",function(){
            onBtnThemUserClick()
        })
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        callApiAndLoadToTable()
    }
    function onBtnEditClick(paramEdit) {
        var vUserId = $(paramEdit).data("id");
        console.log(vUserId);
        const vDETAIL_FORM_URL = "updateUser.html"
        var vUrlSiteToOpen = vDETAIL_FORM_URL + "?" + "id=" + vUserId;
        window.location.href = vUrlSiteToOpen;
    }
    function onBtnDeleteClick(paramDelete) {
        var vLoiNhac = "Bạn chắc chắn muốn xóa?"
        if(confirm(vLoiNhac) == true){
        var vUserId = $(paramDelete).data("id");
        console.log(vUserId);
        //gọi Api xóa user
        callApiDeleteUser(vUserId);
        }
        
    }
    function onBtnThemUserClick(){
        const vDETAIL_FORM_URL = "insertUser.html"
        var vUrlSiteToOpen = vDETAIL_FORM_URL;
        window.location.href = vUrlSiteToOpen;
    }
    
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function callApiAndLoadToTable() {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "GET",
            success: function (paramUser) {
                loadDataToTable(paramUser);
            },
            error: function (paramError) {
                console.log(paramError.status);
            }
        });
    }
    function loadDataToTable(paramUserObj) {
        var vUserTable = $("#table-users");
        // var vTbodyTable = 
        for (var bI = 0; bI < paramUserObj.length; bI++) {
            var vNewRow = $("<tr>").appendTo(vUserTable);
            $("<td>", { html: paramUserObj[bI].id }).appendTo(vNewRow);
            $("<td>", { html: paramUserObj[bI].firstname }).appendTo(vNewRow);
            $("<td>", { html: paramUserObj[bI].lastname }).appendTo(vNewRow);
            $("<td>", { html: paramUserObj[bI].country }).appendTo(vNewRow);
            $("<td>", { html: paramUserObj[bI].subject }).appendTo(vNewRow);
            $("<td>", { html: paramUserObj[bI].customerType }).appendTo(vNewRow);
            $("<td>", { html: paramUserObj[bI].registerStatus }).appendTo(vNewRow);
            //tạo ô action
            var bActionCell = $("<td>").appendTo(vNewRow);
            $("<button>", {
                html: "Sửa",
                class: "btn btn-primary mr-1 edit-user"
            }).data("id", paramUserObj[bI].id)
                .appendTo(bActionCell)
            $("<button>", {
                html: "Xóa",
                class: "btn btn-danger delete-user"
            }).data("id", paramUserObj[bI].id)
                .appendTo(bActionCell)

        }
    }
    function callApiDeleteUser(paramUserId){
        $.ajax({
            url:"http://203.171.20.210:8080/crud-api/users/" + paramUserId,
            type:"DELETE",
            success: function (paramUser) {
                alert("Xóa User thành công");
                window.location.href = "listUsers.html"
            },
            error: function (paramError) {
                console.log(paramError.status);
            }
        })
    }
</script>

<body>
    <div class="container">
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>
        <button class="btn btn-success mb-1" id="btn-them-user">Thêm user</button>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>

</html>